/*
 * Created on Jul 8, 2004
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package diskfiles;

import java.util.*;

//import org.eclipse.jface.dialogs.*;
import org.eclipse.jface.dialogs.*;
import org.eclipse.swt.*;
import org.eclipse.swt.events.*;
import org.eclipse.swt.graphics.*;
import org.eclipse.swt.layout.*;
import org.eclipse.swt.widgets.*;

/**
 * ADD to CLASSPATH SWT.JAR then USE FOLLOWING VM ARG
 * -Djava.library.path=../../plugins\org.eclipse.swt.win32_3.1.0\os\win32\x86\
 */
public class DiskFileApplication
{
    /**
     *  
     */
    public DiskFileApplication()
    {

    }

    /**
     *  
     */
    private void create(Shell shell)
    {
        this.shell = shell;
        Display display = shell.getDisplay();
        taFont = new Font(display, "Arial Unicode MS", 10, SWT.NORMAL);
        defaultFont = new Font(display, "Arial Unicode MS", 10, SWT.NORMAL);

        GridLayout gridLayout = new GridLayout();
        gridLayout.numColumns = 2;
        shell.setLayout(gridLayout);
        instructionLabel = getLabel();

        GridData data = null;
        localeLabel = getLabel();

        localeCombo = new Combo(shell, SWT.DROP_DOWN | SWT.READ_ONLY
                | SWT.SIMPLE);
        localeCombo.add(Locale.getDefault().toString());
        localeCombo.add(taLocale.toString());
        localeCombo.select(0);

        data = new GridData();

        data.horizontalAlignment = GridData.FILL;
        data.grabExcessHorizontalSpace = true;
        localeCombo.setLayoutData(data);

        data = new GridData();
        data.horizontalAlignment = GridData.FILL;
        data.horizontalSpan = 2;
        data.grabExcessHorizontalSpace = true;
        instructionLabel.setLayoutData(data);
        messageLabel = getLabel();

        data = new GridData();
        data.horizontalAlignment = GridData.FILL;
        data.horizontalSpan = 2;
        data.grabExcessHorizontalSpace = true;
        messageLabel.setLayoutData(data);
        diskNameMessageLabel = getLabel();

        diskName = new Text(shell, SWT.BORDER);
        diskName.setText("diskName");
        data = new GridData();
        data.horizontalAlignment = GridData.FILL;
        data.grabExcessHorizontalSpace = true;
        diskName.setLayoutData(data);
        noOfFilesLabel = getLabel();

        noOfFiles = new Text(shell, SWT.BORDER);
        noOfFiles.setText("23");
        data = new GridData();
        data.horizontalAlignment = GridData.FILL;
        data.grabExcessHorizontalSpace = true;
        noOfFiles.setLayoutData(data);
        submitButton = new Button(shell, SWT.PUSH);

        data = new GridData();
        data.horizontalAlignment = GridData.FILL;
        data.horizontalSpan = 2;
        data.grabExcessHorizontalSpace = true;
        submitButton.setLayoutData(data);
        submitButton.addSelectionListener(new SelectionListener()
        {
            public void widgetSelected(SelectionEvent arg0)
            {
                try
                {
                    process();
                } catch (final DiskFileException e)
                {
                    CustomMessageDialog.openError(DiskFileApplication.this.shell,
                            MessagesDlMsg.getErrorMsg(), e.getMessage(), DiskFileApplication.this);
//                    MessageDialog.openError(DiskFileApplication.this.shell,
//                            MessagesDlMsg.getErrorMsg(), e.getMessage());

                }
            }

            public void widgetDefaultSelected(SelectionEvent arg0)
            {
                // TODO Auto-generated method stub
            }
        });

        localeCombo.addSelectionListener(new SelectionListener()
        {

            public void widgetSelected(SelectionEvent e)
            {
                String locale = localeCombo.getText();
                
                Locale.setDefault(new Locale(locale));
                /*
                 * This reloading of the messenger cache will not work if the messenger is not reloadable.
                 * It is unnecessary if there is no cache.
                 */
                MessagesDlMsg.reloadDlMessengerCache();
                DiskFileException.reloadDlMessengerCache();
                updateLabels();

            }

            public void widgetDefaultSelected(SelectionEvent e)
            {
                // TODO Auto-generated method stub

            }
        });

        updateLabels();

    }

    /**
     *  
     */
    private void dispose()
    {
        defaultFont.dispose();
        taFont.dispose();
    }

    /**
     * @param locale
     */
    private void updateLabels()
    {
        changeFonts();

        labelWithExtraSpaces(MessagesDlMsg.getSelectLocaleMsg(), localeLabel, 20);
        labelWithExtraSpaces(MessagesDlMsg.getInstructionMsg(),
                instructionLabel, 100);
        messageLabel.setText(MessagesDlMsg.getDiskFilesMsg("diskName", 23));
        diskNameMessageLabel.setText(MessagesDlMsg.getDiskNameMsg());
        noOfFilesLabel.setText(MessagesDlMsg.getNoOfFilesMsg());
        submitButton.setText(MessagesDlMsg.getSubmitMsg());
    }

    /**
     *  
     */
    private void changeFonts()
    {
        Font font = getFont();
        
//        localeLabel.setFont(font);
//        instructionLabel.setFont(font);
//        messageLabel.setFont(font);
//        diskNameMessageLabel.setFont(font);
//        noOfFilesLabel.setFont(font);
//        submitButton.setFont(font);
        Control[] controls=shell.getChildren();
        for (int i = 0; i < controls.length; i++)
        {
            controls[i].setFont(font);
        }
        shell.setFont(font);
    }

    /**
     * @return
     */
    public Font getFont()
    {
        Font font = null;
        if (taLocale.equals(Locale.getDefault()))
        {
            font = taFont;
        }
        else
        {
            font = defaultFont;
        }
        return font;
    }

    /**
     * @param text
     *            TODO
     * @param label
     *            TODO
     * @param width
     *            TODO
     *  
     */
    private void labelWithExtraSpaces(String text, Label label, int width)
    {
        String msg = text;
        StringBuffer buf = new StringBuffer(msg);
        for (int i = msg.length() - 1; i < width; i++)
        {
            buf.append(' ');
        }
        label.setText(buf.toString());
    }

    private Label localeLabel;

    private Combo localeCombo;

    private Label instructionLabel;

    private Label messageLabel;

    private Label diskNameMessageLabel;

    private Label noOfFilesLabel;

    private Button submitButton;

    private Text diskName;

    private Text noOfFiles;

    private Shell shell;

    private static final Locale taLocale = new Locale("ta");

    private Font taFont;

    private Font defaultFont;

    public static void main(String[] args)
    {
        Display display = new Display();
        Shell shell = new Shell(display);
        DiskFileApplication diskFileApplication = new DiskFileApplication();
        diskFileApplication.create(shell);
        shell.pack();
        shell.open();
        while (!shell.isDisposed())
        {
            if (!display.readAndDispatch())
                display.sleep();
        }
        diskFileApplication.dispose();
        display.dispose();

    }

    private void process() throws DiskFileException
    {
        String diskNameValue = diskName.getText();
        if (diskNameValue.trim().length() == 0)
            throw DiskFileException.getEmptyDiskNameException();
        if (diskNameValue.length() > 8)
            throw DiskFileException.getLargeDiskException(8, diskNameValue,
                    diskNameValue.length());
        try
        {
            int noOfDisksValue = Integer.parseInt(noOfFiles.getText());
            if (noOfDisksValue < 0 || noOfDisksValue > 50)
                throw DiskFileException.getNoOfFilesOutOfRangeException(0, 50,
                        noOfDisksValue);
            messageLabel.setText(MessagesDlMsg.getDiskFilesMsg(diskNameValue,
                    noOfDisksValue));
        } catch (NumberFormatException e)
        {
            throw DiskFileException.getInvalidNumberOfFileException(noOfFiles
                    .getText(), e);
        }
    }

    /**
     * @param isTa
     * @param font
     * @param shell
     * @return
     */
    private Label getLabel()
    {
        Label label0 = new Label(shell, SWT.NONE);
        //        if (isTa)
        //            label0.setFont(font);
        return label0;
    }

}