package diskfiles;
import com.raghuraman.rbcore.keycontrol.msg.strings.MsgWithReloadableCacheAndOneLocale;
import com.raghuraman.rbcore.keycontrol.base.BaseStringCode;
import com.raghuraman.rbcore.keycontrol.msgobject.dl.Message;
public class DiskFileException extends Exception  implements Message
{
   /**
   * name of the resource bundle
   */
   private static final String resouceBundleName = "diskfiles.DiskFile";
   /**
   * The  messenger field is a convenience field used by this class
   */
   private static final MsgWithReloadableCacheAndOneLocale dlMessenger = new MsgWithReloadableCacheAndOneLocale(resouceBundleName);
   public static final DiskFileException getEmptyDiskNameException()
   {
      return new DiskFileException(Nested.EMPTY_DISK_NAME);

   }
   public static final DiskFileException getEmptyDiskNameException(Throwable cause)
   {
      return new DiskFileException(Nested.EMPTY_DISK_NAME, cause);

   }
   public static final DiskFileException getLargeDiskException(int maxDiskNameLength, String diskName, int diskNameLength)
   {
      Object[] arr =
      {
         new Integer(maxDiskNameLength), diskName, new Integer(diskNameLength)
      };
      return new DiskFileException(Nested.LARGE_DISK, arr);

   }
   public static final DiskFileException getLargeDiskException(int maxDiskNameLength, String diskName, int diskNameLength, Throwable cause)
   {
      Object[] arr =
      {
         new Integer(maxDiskNameLength), diskName, new Integer(diskNameLength)
      };
      return new DiskFileException(Nested.LARGE_DISK, cause, arr);

   }
   public static final DiskFileException getNoOfFilesOutOfRangeException(int minInclusive, int max, int value)
   {
      Object[] arr =
      {
         new Integer(minInclusive), new Integer(max), new Integer(value)
      };
      return new DiskFileException(Nested.NO_OF_FILES_OUT_OF_RANGE, arr);

   }
   public static final DiskFileException getNoOfFilesOutOfRangeException(int minInclusive, int max, int value, Throwable cause)
   {
      Object[] arr =
      {
         new Integer(minInclusive), new Integer(max), new Integer(value)
      };
      return new DiskFileException(Nested.NO_OF_FILES_OUT_OF_RANGE, cause, arr);

   }
   public static final DiskFileException getInvalidNumberOfFileException(String input)
   {
      Object[] arr =
      {
         input
      };
      return new DiskFileException(Nested.INVALID_NUMBER_OF_FILE, arr);

   }
   public static final DiskFileException getInvalidNumberOfFileException(String input, Throwable cause)
   {
      Object[] arr =
      {
         input
      };
      return new DiskFileException(Nested.INVALID_NUMBER_OF_FILE, cause, arr);

   }
   /**
   * gets the internationalized message
   * @return message
   */
   public final String getMessage()
   {
      return dlMessenger.getMessage(super.getMessage(), arr);

   }
   /**
   * The  arr field is a instance final field and is used to hold the parameters of the message.
   */
   private final Object[] arr;
   /**
   * All constructors are private to prevent unnecessary instantiation of this class
   * @param key
   * @param cause
   * @param arr
   */
   private DiskFileException(String key, Throwable cause, Object[] arr)
   {
      super (key, cause);
      this.arr=arr;

   }
   /**
   * All constructors are private to prevent unnecessary instantiation of this class
   * @param key
   * @param cause
   */
   private DiskFileException(String key, Throwable cause)
   {
      this (key, cause, null);

   }
   /**
   * All constructors are private to prevent unnecessary instantiation of this class
   * @param key
   * @param arr
   */
   private DiskFileException(String key, Object[] arr)
   {
      this (key, null, arr);

   }
   /**
   * All constructors are private to prevent unnecessary instantiation of this class
   * @param key
   */
   private DiskFileException(String key)
   {
      this (key, null, null);

   }
   /**
   * Currently this method simply reloads the cache and returns true.  In case reloading is not needed it
   *  may be turned off from the  general settings page of the rb editor.
   * @return A boolean flag to indicate whether reloading of the cache was attempted
   */
   public static final boolean reloadDlMessengerCache()
   {
      dlMessenger.updateCache(resouceBundleName);
      return true;

   }
   protected static interface Nested extends BaseStringCode
   {
      public static final String EMPTY_DISK_NAME = Ctrl.getFirstField();
      public static final String LARGE_DISK = Ctrl.getField();
      public static final String NO_OF_FILES_OUT_OF_RANGE = Ctrl.getField();
      public static final String INVALID_NUMBER_OF_FILE = Ctrl.getLastField();

   }

}
